class Conv1d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  kernel_size : Final[Tuple[int]] = (3,)
  stride : Final[Tuple[int]] = (1,)
  groups : Final[int] = 1
  out_channels : Final[int] = 33
  in_channels : Final[int] = 4
  padding_mode : Final[str] = "zeros"
  padding : Final[Tuple[int]] = (0,)
  output_padding : Final[Tuple[int]] = (0,)
  dilation : Final[Tuple[int]] = (1,)
  def forward(self: __torch__.torch.nn.modules.conv.Conv1d,
    input: Tensor) -> Tensor:
    weight = self.weight
    bias = self.bias
    _0 = (self)._conv_forward(input, weight, bias, )
    return _0
  def _conv_forward(self: __torch__.torch.nn.modules.conv.Conv1d,
    input: Tensor,
    weight: Tensor,
    bias: Optional[Tensor]) -> Tensor:
    _1 = torch.conv1d(input, weight, bias, [1], [0], [1])
    return _1
class ConvTranspose1d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  kernel_size : Final[Tuple[int]] = (3,)
  stride : Final[Tuple[int]] = (1,)
  groups : Final[int] = 1
  out_channels : Final[int] = 33
  in_channels : Final[int] = 4
  padding_mode : Final[str] = "zeros"
  padding : Final[Tuple[int]] = (0,)
  output_padding : Final[Tuple[int]] = (0,)
  dilation : Final[Tuple[int]] = (1,)
  def forward(self: __torch__.torch.nn.modules.conv.ConvTranspose1d,
    input: Tensor,
    output_size: Optional[List[int]]=None) -> Tensor:
    output_padding = (self)._output_padding(input, output_size, [1], [0], [3], [1], )
    weight = self.weight
    bias = self.bias
    _2 = torch.conv_transpose1d(input, weight, bias, [1], [0], output_padding, 1, [1])
    return _2
  def _output_padding(self: __torch__.torch.nn.modules.conv.ConvTranspose1d,
    input: Tensor,
    output_size: Optional[List[int]],
    stride: List[int],
    padding: List[int],
    kernel_size: List[int],
    dilation: Optional[List[int]]=None) -> List[int]:
    _3 = "output_size must have {} or {} elements (got {})"
    _4 = "requested an output size of {}, but valid sizes range from {} to {} (for an input of {})"
    if torch.__is__(output_size, None):
      ret = [0]
    else:
      output_size0 = unchecked_cast(List[int], output_size)
      k = torch.sub(torch.dim(input), 2)
      _5 = torch.eq(torch.len(output_size0), torch.add(k, 2))
      if _5:
        output_size1 = torch.slice(output_size0, 2)
      else:
        output_size1 = output_size0
      _6 = torch.ne(torch.len(output_size1), k)
      if _6:
        _7 = torch.format(_3, k, torch.add(k, 2), torch.len(output_size1))
        ops.prim.RaiseException(_7)
      else:
        pass
      min_sizes = annotate(List[int], [])
      max_sizes = annotate(List[int], [])
      dilation0: Optional[List[int]] = dilation
      for d in range(k):
        _8 = torch.size(input, torch.add(d, 2))
        _9 = torch.mul(torch.sub(_8, 1), stride[d])
        _10 = torch.sub(_9, torch.mul(2, padding[d]))
        _11 = torch.__isnot__(dilation0, None)
        if _11:
          dilation2 = unchecked_cast(List[int], dilation0)
          _12, dilation1 = dilation2[d], dilation2
        else:
          _12, dilation1 = 1, dilation0
        _13 = torch.mul(_12, torch.sub(kernel_size[d], 1))
        dim_size = torch.add(torch.add(_10, _13), 1)
        _14 = torch.append(min_sizes, dim_size)
        _15 = torch.add(min_sizes[d], stride[d])
        _16 = torch.append(max_sizes, torch.sub(_15, 1))
        dilation0 = dilation1
      for i in range(torch.len(output_size1)):
        size = output_size1[i]
        min_size = min_sizes[i]
        max_size = max_sizes[i]
        if torch.lt(size, min_size):
          _17 = True
        else:
          _17 = torch.gt(size, max_size)
        if _17:
          _18 = torch.slice(torch.size(input), 2)
          _19 = torch.format(_4, output_size1, min_sizes, max_sizes, _18)
          ops.prim.RaiseException(_19)
        else:
          pass
      res = annotate(List[int], [])
      for d0 in range(k):
        _20 = torch.sub(output_size1[d0], min_sizes[d0])
        _21 = torch.append(res, _20)
      ret = res
    return ret
class Conv2d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  kernel_size : Final[Tuple[int, int]] = (3, 3)
  stride : Final[Tuple[int, int]] = (1, 1)
  groups : Final[int] = 1
  out_channels : Final[int] = 33
  in_channels : Final[int] = 4
  padding_mode : Final[str] = "zeros"
  padding : Final[Tuple[int, int]] = (0, 0)
  output_padding : Final[Tuple[int, int]] = (0, 0)
  dilation : Final[Tuple[int, int]] = (1, 1)
  def forward(self: __torch__.torch.nn.modules.conv.Conv2d,
    input: Tensor) -> Tensor:
    weight = self.weight
    bias = self.bias
    _22 = (self)._conv_forward(input, weight, bias, )
    return _22
  def _conv_forward(self: __torch__.torch.nn.modules.conv.Conv2d,
    input: Tensor,
    weight: Tensor,
    bias: Optional[Tensor]) -> Tensor:
    _23 = torch.conv2d(input, weight, bias, [1, 1], [0, 0], [1, 1])
    return _23
class ConvTranspose2d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  kernel_size : Final[Tuple[int, int]] = (3, 3)
  stride : Final[Tuple[int, int]] = (1, 1)
  groups : Final[int] = 1
  out_channels : Final[int] = 33
  in_channels : Final[int] = 4
  padding_mode : Final[str] = "zeros"
  padding : Final[Tuple[int, int]] = (0, 0)
  output_padding : Final[Tuple[int, int]] = (0, 0)
  dilation : Final[Tuple[int, int]] = (1, 1)
  def forward(self: __torch__.torch.nn.modules.conv.ConvTranspose2d,
    input: Tensor,
    output_size: Optional[List[int]]=None) -> Tensor:
    output_padding = (self)._output_padding(input, output_size, [1, 1], [0, 0], [3, 3], [1, 1], )
    weight = self.weight
    bias = self.bias
    _24 = torch.conv_transpose2d(input, weight, bias, [1, 1], [0, 0], output_padding, 1, [1, 1])
    return _24
  def _output_padding(self: __torch__.torch.nn.modules.conv.ConvTranspose2d,
    input: Tensor,
    output_size: Optional[List[int]],
    stride: List[int],
    padding: List[int],
    kernel_size: List[int],
    dilation: Optional[List[int]]=None) -> List[int]:
    _25 = "output_size must have {} or {} elements (got {})"
    _26 = "requested an output size of {}, but valid sizes range from {} to {} (for an input of {})"
    if torch.__is__(output_size, None):
      ret = [0, 0]
    else:
      output_size2 = unchecked_cast(List[int], output_size)
      k = torch.sub(torch.dim(input), 2)
      _27 = torch.eq(torch.len(output_size2), torch.add(k, 2))
      if _27:
        output_size3 = torch.slice(output_size2, 2)
      else:
        output_size3 = output_size2
      _28 = torch.ne(torch.len(output_size3), k)
      if _28:
        _29 = torch.format(_25, k, torch.add(k, 2), torch.len(output_size3))
        ops.prim.RaiseException(_29)
      else:
        pass
      min_sizes = annotate(List[int], [])
      max_sizes = annotate(List[int], [])
      dilation3: Optional[List[int]] = dilation
      for d in range(k):
        _30 = torch.size(input, torch.add(d, 2))
        _31 = torch.mul(torch.sub(_30, 1), stride[d])
        _32 = torch.sub(_31, torch.mul(2, padding[d]))
        _33 = torch.__isnot__(dilation3, None)
        if _33:
          dilation5 = unchecked_cast(List[int], dilation3)
          _34, dilation4 = dilation5[d], dilation5
        else:
          _34, dilation4 = 1, dilation3
        _35 = torch.mul(_34, torch.sub(kernel_size[d], 1))
        dim_size = torch.add(torch.add(_32, _35), 1)
        _36 = torch.append(min_sizes, dim_size)
        _37 = torch.add(min_sizes[d], stride[d])
        _38 = torch.append(max_sizes, torch.sub(_37, 1))
        dilation3 = dilation4
      for i in range(torch.len(output_size3)):
        size = output_size3[i]
        min_size = min_sizes[i]
        max_size = max_sizes[i]
        if torch.lt(size, min_size):
          _39 = True
        else:
          _39 = torch.gt(size, max_size)
        if _39:
          _40 = torch.slice(torch.size(input), 2)
          _41 = torch.format(_26, output_size3, min_sizes, max_sizes, _40)
          ops.prim.RaiseException(_41)
        else:
          pass
      res = annotate(List[int], [])
      for d1 in range(k):
        _42 = torch.sub(output_size3[d1], min_sizes[d1])
        _43 = torch.append(res, _42)
      ret = res
    return ret
class Conv3d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  kernel_size : Final[Tuple[int, int, int]] = (2, 2, 2)
  stride : Final[Tuple[int, int, int]] = (1, 1, 1)
  groups : Final[int] = 1
  out_channels : Final[int] = 33
  in_channels : Final[int] = 4
  padding_mode : Final[str] = "zeros"
  padding : Final[Tuple[int, int, int]] = (0, 0, 0)
  output_padding : Final[Tuple[int, int, int]] = (0, 0, 0)
  dilation : Final[Tuple[int, int, int]] = (1, 1, 1)
  def forward(self: __torch__.torch.nn.modules.conv.Conv3d,
    input: Tensor) -> Tensor:
    weight = self.weight
    bias = self.bias
    _44 = (self)._conv_forward(input, weight, bias, )
    return _44
  def _conv_forward(self: __torch__.torch.nn.modules.conv.Conv3d,
    input: Tensor,
    weight: Tensor,
    bias: Optional[Tensor]) -> Tensor:
    _45 = torch.conv3d(input, weight, bias, [1, 1, 1], [0, 0, 0], [1, 1, 1])
    return _45
class ConvTranspose3d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  kernel_size : Final[Tuple[int, int, int]] = (3, 3, 3)
  stride : Final[Tuple[int, int, int]] = (1, 1, 1)
  groups : Final[int] = 1
  out_channels : Final[int] = 33
  in_channels : Final[int] = 4
  padding_mode : Final[str] = "zeros"
  padding : Final[Tuple[int, int, int]] = (0, 0, 0)
  output_padding : Final[Tuple[int, int, int]] = (0, 0, 0)
  dilation : Final[Tuple[int, int, int]] = (1, 1, 1)
  def forward(self: __torch__.torch.nn.modules.conv.ConvTranspose3d,
    input: Tensor,
    output_size: Optional[List[int]]=None) -> Tensor:
    output_padding = (self)._output_padding(input, output_size, [1, 1, 1], [0, 0, 0], [3, 3, 3], [1, 1, 1], )
    weight = self.weight
    bias = self.bias
    _46 = torch.conv_transpose3d(input, weight, bias, [1, 1, 1], [0, 0, 0], output_padding, 1, [1, 1, 1])
    return _46
  def _output_padding(self: __torch__.torch.nn.modules.conv.ConvTranspose3d,
    input: Tensor,
    output_size: Optional[List[int]],
    stride: List[int],
    padding: List[int],
    kernel_size: List[int],
    dilation: Optional[List[int]]=None) -> List[int]:
    _47 = "output_size must have {} or {} elements (got {})"
    _48 = "requested an output size of {}, but valid sizes range from {} to {} (for an input of {})"
    if torch.__is__(output_size, None):
      ret = [0, 0, 0]
    else:
      output_size4 = unchecked_cast(List[int], output_size)
      k = torch.sub(torch.dim(input), 2)
      _49 = torch.eq(torch.len(output_size4), torch.add(k, 2))
      if _49:
        output_size5 = torch.slice(output_size4, 2)
      else:
        output_size5 = output_size4
      _50 = torch.ne(torch.len(output_size5), k)
      if _50:
        _51 = torch.format(_47, k, torch.add(k, 2), torch.len(output_size5))
        ops.prim.RaiseException(_51)
      else:
        pass
      min_sizes = annotate(List[int], [])
      max_sizes = annotate(List[int], [])
      dilation6: Optional[List[int]] = dilation
      for d in range(k):
        _52 = torch.size(input, torch.add(d, 2))
        _53 = torch.mul(torch.sub(_52, 1), stride[d])
        _54 = torch.sub(_53, torch.mul(2, padding[d]))
        _55 = torch.__isnot__(dilation6, None)
        if _55:
          dilation8 = unchecked_cast(List[int], dilation6)
          _56, dilation7 = dilation8[d], dilation8
        else:
          _56, dilation7 = 1, dilation6
        _57 = torch.mul(_56, torch.sub(kernel_size[d], 1))
        dim_size = torch.add(torch.add(_54, _57), 1)
        _58 = torch.append(min_sizes, dim_size)
        _59 = torch.add(min_sizes[d], stride[d])
        _60 = torch.append(max_sizes, torch.sub(_59, 1))
        dilation6 = dilation7
      for i in range(torch.len(output_size5)):
        size = output_size5[i]
        min_size = min_sizes[i]
        max_size = max_sizes[i]
        if torch.lt(size, min_size):
          _61 = True
        else:
          _61 = torch.gt(size, max_size)
        if _61:
          _62 = torch.slice(torch.size(input), 2)
          _63 = torch.format(_48, output_size5, min_sizes, max_sizes, _62)
          ops.prim.RaiseException(_63)
        else:
          pass
      res = annotate(List[int], [])
      for d2 in range(k):
        _64 = torch.sub(output_size5[d2], min_sizes[d2])
        _65 = torch.append(res, _64)
      ret = res
    return ret
